﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Diagnostics;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.Diagnostics;
using Microsoft.WindowsAzure.ServiceRuntime;
using Microsoft.WindowsAzure.Diagnostics.Management;

namespace LoggingWebRole
{
    public partial class admin : System.Web.UI.Page
    {
        protected void TransferLogsBtn_Click(object sender, EventArgs e)
        {
            try
            {
                // Force an on-demand transfer of file-based logs like IIS logs, failed request logs, etc.

                var diagManager = new DeploymentDiagnosticManager(RoleEnvironment.GetConfigurationSettingValue("DiagnosticsConnectionString"), RoleEnvironment.DeploymentId);
                var roleInstDiagMgr = diagManager.GetRoleInstanceDiagnosticManager("LoggingWebRole", RoleEnvironment.CurrentRoleInstance.Id);
                DataBufferName dataBuffersToTransfer = DataBufferName.Directories;
                OnDemandTransferOptions transferOptions = new OnDemandTransferOptions();
                transferOptions.From = DateTime.MinValue;
                transferOptions.To = DateTime.UtcNow;
                Guid requestID = Guid.Empty;

                try
                {
                    // Can throw an exception if a transfer request is in progress.  If so, cancel it.
                    requestID = roleInstDiagMgr.BeginOnDemandTransfer(dataBuffersToTransfer,
                                         transferOptions);
                }
                catch (System.InvalidOperationException exp)
                {
                    // Cancel the existing request
                    roleInstDiagMgr.CancelOnDemandTransfers(DataBufferName.Directories);

                    // Display the message
                    RequestLbl.Text = exp.Message + " - Cancelled.";
                }

                if (requestID != Guid.Empty)
                        RequestLbl.Text = requestID.ToString();
            }
            catch (Microsoft.WindowsAzure.StorageClient.StorageServerException sexp)
            {
                RequestLbl.Text = "An error occurred: " + sexp.Message;
            }
        }
    }
}